@ECHO OFF

REM Create enviroment variable to tell us where the assembler and linker are
set asm=..\ti8xasm.exe
set link=..\xlink.exe

REM create a couple of folder, if need be

IF EXIST objs GOTO skipobjs
ECHO Creating 'objs' folder...
mkdir objs
:skipobjs

IF EXIST programs GOTO skipprograms
ECHO Creating 'programs' folder...
mkdir programs
:skipprograms

REM Now for the fun stuff

ECHO *****************************
ECHO Compiling for the TI-83+
ECHO *****************************

%asm% -oobjs\header.obj -dTI83P header.z80 
if errorlevel 5 goto fail

%asm% -oobjs\demo.obj -dTI83P demo.z80 
if errorlevel 5 goto fail

%asm% -oobjs\lissy.obj -dTI83P lissy.z80 
if errorlevel 5 goto fail

%asm% -oobjs\title.obj -dTI83P title.z80 
if errorlevel 5 goto fail

ECHO *****************************
ECHO * Linking for the TI-83+
ECHO *****************************

%link% -l linkfile -t ti83+
if errorlevel 5 goto fail

IF EXIST programs\demo.8xp del programs\demo.8xp
ren programs\demo.83p demo.8xp

ECHO *****************************
ECHO Compiling for the TI-83
ECHO *****************************

%asm% -oobjs\header.obj -dTI83 header.z80 
if errorlevel 5 goto fail

%asm% -oobjs\demo.obj -dTI83 demo.z80 
if errorlevel 5 goto fail

%asm% -oobjs\lissy.obj -dTI83 lissy.z80 
if errorlevel 5 goto fail

%asm% -oobjs\title.obj -dTI83 title.z80 
if errorlevel 5 goto fail

ECHO *****************************
ECHO * Linking for the TI-83
ECHO *****************************

%link% -l linkfile -t ti83
if errorlevel 5 goto fail

ECHO Success!
GOTO exit

:fail
ECHO 
ECHO An error occured during compilations

:exit