#include "symbol.h"
#include "lexer.h"
#include "rpn.h"
#include "asmy.h"

struct sLexInitString localstrings[] =
{
    "adc",	T_Z80_ADC,
    "add",	T_Z80_ADD,
    "and",	T_Z80_AND,
    "bit",	T_Z80_BIT,
    "call",	T_Z80_CALL,
    "ccf",	T_Z80_CCF,
	"cpd",	T_Z80_CPD,
	"cpdr",	T_Z80_CPDR,
	"cpi",	T_Z80_CPI,
	"cpir",	T_Z80_CPIR,
    "cpl",	T_Z80_CPL,
    "cp",	T_Z80_CP,
    "daa",	T_Z80_DAA,
    "dec",	T_Z80_DEC,
    "di",	T_Z80_DI,
	"djnz",	T_Z80_DJNZ,
    "ei",	T_Z80_EI,
    "ex",	T_Z80_EX,
	"exx",	T_Z80_EXX,
    "halt",	T_Z80_HALT,
	"im",	T_Z80_IM,
	"in",	T_Z80_IN,
	"ind",	T_Z80_IND,
	"indr",	T_Z80_INDR,
	"ini",	T_Z80_INI,
	"inir",	T_Z80_INIR,
    "inc",	T_Z80_INC,
    "jp",	T_Z80_JP,
    "jr",	T_Z80_JR,
    "ld",	T_Z80_LD,
	"ldd",	T_Z80_LDD,
	"lddr",	T_Z80_LDDR,
    "ldi",	T_Z80_LDI,
	"ldir",	T_Z80_LDIR,
	"neg",	T_Z80_NEG,
    "nop",	T_Z80_NOP,
    "or",	T_Z80_OR,
	"out",	T_Z80_OUT,
	"outd",	T_Z80_OUTD,
	"otdr",	T_Z80_OTDR,
	"outi",	T_Z80_OUTI,
	"otir",	T_Z80_OTIR,
    "pop",	T_Z80_POP,
    "push",	T_Z80_PUSH,
    "res",	T_Z80_RES,
    "ret",	T_Z80_RET,
	"reti",	T_Z80_RETI,
	"retn",	T_Z80_RETN,
    "rlca",	T_Z80_RLCA,
    "rlc",	T_Z80_RLC,
    "rla",	T_Z80_RLA,
    "rl",	T_Z80_RL,
	"rld",	T_Z80_RLD,
    "rrc",	T_Z80_RRC,
    "rrca",	T_Z80_RRCA,
    "rra",	T_Z80_RRA,
    "rr",	T_Z80_RR,
	"rrd",	T_Z80_RRD,
    "rst",	T_Z80_RST,
    "sbc",	T_Z80_SBC,
    "scf",	T_Z80_SCF,

// Handled by globallex.c
// "set"        ,       T_POP_SET,

    "sla",	T_Z80_SLA,
    "sra",	T_Z80_SRA,
    "srl",	T_Z80_SRL,
    "sub",	T_Z80_SUB,
    "xor",	T_Z80_XOR,

    "nz",	T_CC_NZ,
    "z",	T_CC_Z,
    "nc",	T_CC_NC,
//      "c"             ,       T_MODE_C
	"po",	T_CC_PO,
	"pe",	T_CC_PE,
	"p",	T_CC_P,
	"m",	T_CC_M,

    "[hl]", T_MODE_HL_IND, 
    "hl",	T_MODE_HL,
	"af'",	T_MODE_AFP,
    "af",	T_MODE_AF,
	"i",	T_MODE_I,
	"ix",	T_MODE_IX,
	"iy",	T_MODE_IY,
    "[bc]",	T_MODE_BC_IND,
    "bc",	T_MODE_BC,
    "[de]",	T_MODE_DE_IND,
    "de",	T_MODE_DE,
    "[sp]",	T_MODE_SP_IND,
    "sp",	T_MODE_SP,
    "a",	T_MODE_A,
    "b",	T_MODE_B,
    "[$ff00+c]", T_MODE_C_IND,
    "[c]",	T_MODE_C_IND,
    "c",	T_MODE_C,
    "d",	T_MODE_D,
    "e",	T_MODE_E,
    "h",	T_MODE_H,
    "l",	T_MODE_L,

    NULL, 0
};