#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "mylink.h"
#include "mapfile.h"
#include "main.h"
#include "assign.h"

char	tzOutname[_MAX_PATH];
BBOOL	oOutput=0;

void writehome( FILE *f )
{
	struct sSection *pSect;
	UBYTE	*mem;

	if( mem=(UBYTE *)malloc(MaxAvail[BANK_HOME]) )
	{
		if( fillchar!=-1 )
		{
			memset( mem, fillchar, MaxAvail[BANK_HOME] );
		}
		MapfileInitBank( 0 );

		pSect=pSections;
		while( pSect )
		{
			if( pSect->Type==SECT_HOME )
			{
				memcpy( mem+pSect->nOrg, pSect->pData, pSect->nByteSize );
				MapfileWriteSection( pSect );
			}
			pSect=pSect->pNext;
		}

		MapfileCloseBank( area_Avail(0) );

		fwrite( mem, 1, MaxAvail[BANK_HOME], f );
		free( mem );
	}
}

void writebank( FILE *f, SLONG bank )
{
	struct sSection *pSect;
	UBYTE	*mem;

	if( mem=(UBYTE *)malloc(MaxAvail[bank]) )
	{
		if( fillchar!=-1 )
		{
			memset( mem, fillchar, MaxAvail[bank] );
		}

		MapfileInitBank( bank );

		pSect=pSections;
		while( pSect )
		{
			if( pSect->Type==SECT_CODE && pSect->nBank==bank )
			{
				memcpy( mem+pSect->nOrg-0x4000, pSect->pData, pSect->nByteSize );
				MapfileWriteSection( pSect );
			}
			pSect=pSect->pNext;
		}

		MapfileCloseBank( area_Avail(bank) );

		fwrite( mem, 1, MaxAvail[bank], f );
		free( mem );
	}
}

void out_Setname( char *tzOutputfile )
{
	strcpy( tzOutname, tzOutputfile );
	oOutput=1;
}

void	GBROM_Output( void )
{
	SLONG i;
	FILE *f;

	if( f=fopen(tzOutname,"wb") )
	{
		writehome( f );
		for( i=1; i<=MaxBankUsed; i+=1 )
			writebank( f, i );

		fclose( f );
	}

	for( i=256; i<MAXBANKS; i+=1 )
	{
		struct	sSection	*pSect;
		MapfileInitBank( i );
		pSect=pSections;
		while( pSect )
		{
			if( pSect->nBank==i )
			{
				MapfileWriteSection( pSect );
			}
			pSect=pSect->pNext;
		}
		MapfileCloseBank( area_Avail(i) );
	}
}

void	PSION2_Output( void )
{
	FILE *f;

	if( f=fopen(tzOutname,"wb") )
	{
		struct sSection *pSect;
		UBYTE	*mem;
		ULONG	size=MaxAvail[0]-area_Avail(0);
		ULONG	relocpatches;

		fputc( size>>24, f );
		fputc( size>>16, f );
		fputc( size>>8, f );
		fputc( size, f );

		if( mem=(UBYTE *)malloc(MaxAvail[0]-area_Avail(0)) )
		{
			MapfileInitBank( 0 );

			pSect=pSections;
			while( pSect )
			{
				if( pSect->Type==SECT_CODE )
				{
					memcpy( mem+pSect->nOrg, pSect->pData, pSect->nByteSize );
					MapfileWriteSection( pSect );
				}
				else
				{
					memset( mem+pSect->nOrg, 0, pSect->nByteSize );
				}
				pSect=pSect->pNext;
			}

			MapfileCloseBank( area_Avail(0) );

			fwrite( mem, 1, MaxAvail[0]-area_Avail(0), f );
			free( mem );
		}

		relocpatches=0;
		pSect=pSections;
		while( pSect )
		{
			struct	sPatch	*pPatch;

			pPatch=pSect->pPatches;

			while( pPatch )
			{
				if( pPatch->oRelocPatch )
				{
					relocpatches+=1;
				}
				pPatch=pPatch->pNext;
			}
			pSect=pSect->pNext;
		}

		fputc( relocpatches>>24, f );
		fputc( relocpatches>>16, f );
		fputc( relocpatches>>8, f );
		fputc( relocpatches, f );

		pSect=pSections;
		while( pSect )
		{
			struct	sPatch	*pPatch;

			pPatch=pSect->pPatches;

			while( pPatch )
			{
				if( pPatch->oRelocPatch )
				{
					ULONG	address;

					address=pPatch->nOffset+pSect->nOrg;
					fputc( address>>24, f );
					fputc( address>>16, f );
					fputc( address>>8, f );
					fputc( address, f );
				}
				pPatch=pPatch->pNext;
			}
			pSect=pSect->pNext;
		}



		fclose( f );
	}
}

/*
 * ASJ: New function to output to a ti83 .83p or .83x file
 *      Note my ambition.  I do checksums and everything!
 *		No need for RGBFIX here.
 *      w00t!
 *
 */
void	TI83_Output( BBOOL isPlus )
{
	FILE *f;

	unsigned char program[0x10000];	//the ti-83 does use bankswitching
							//(well, not that our programmer can use)
							//so this will be fine

	unsigned char unsquished[0x10000];	//temp buffer for the unsquished program
								//(if needs be)

	int unsquishedIndex;

	int	beginningOfProgram;		//the first location defined.  Can be no less than
								//the entry point of all ti83(+) ASM programs (Set later)

	int endOfProgram;		//one byte past the last location defined in the program

	struct sSection *pSect;	//pointer to the sectoin we're evaluating

	char comment[40];		//comment to leave in the 83p file

	int dataSize;			//size of the data section of the 83p file
							//used in generating the header

	char *p;
	char varName[8];		//the variable name to use
	int index;

	int checksum = 0;		//checksum of the data area

	//decide where the beginning of the program is
	if(isPlus)
		beginningOfProgram = 0x9D95;
	else
		beginningOfProgram = 0x9327;

	endOfProgram = beginningOfProgram;

	if( f=fopen(tzOutname,"wb") )
	{
		//First, output all the code sections to a buffer, updating the mapfile as we go
		MapfileInitBank( 0 );
		
		pSect = pSections;
		while(pSect)
		{
			if(pSect->Type == SECT_CODE)
			{
				//write it into the program buffer
				memcpy(&program[pSect->nOrg], pSect->pData, pSect->nByteSize);
				
				//update beginningOfProgram if need be
				if(pSect->nOrg < beginningOfProgram)
					beginningOfProgram = pSect->nOrg;

				//update endOfProgram if need be
				if(pSect->nOrg + pSect->nByteSize > endOfProgram)
					endOfProgram = pSect->nOrg + pSect->nByteSize;				

				//tell the mapfile about it
				MapfileWriteSection(pSect);
			}
			pSect = pSect->pNext;
		} // end while

		MapfileCloseBank(0);

		//now, let the mapfile now about all the saferam sectoins
		MapfileInitBank(BANK_SAVESCREEN);
		pSect = pSections;
		while(pSect)
		{
			if(pSect->nBank == BANK_SAVESCREEN)
				MapfileWriteSection(pSect);

			pSect = pSect->pNext;
		}
		MapfileCloseBank(area_Avail(BANK_SAVESCREEN));

		MapfileInitBank(BANK_STATVARS);
		pSect = pSections;
		while(pSect)
		{
			if(pSect->nBank == BANK_STATVARS)
				MapfileWriteSection(pSect);

			pSect = pSect->pNext;
		}
		MapfileCloseBank(area_Avail(BANK_STATVARS));

		MapfileInitBank(BANK_TEXTSHADOW);
		pSect = pSections;
		while(pSect)
		{
			if(pSect->nBank == BANK_TEXTSHADOW)
				MapfileWriteSection(pSect);

			pSect = pSect->pNext;
		}
		MapfileCloseBank(area_Avail(BANK_TEXTSHADOW));

		MapfileInitBank(BANK_PLOTSCREEN);
		pSect = pSections;
		while(pSect)
		{
			if(pSect->nBank == BANK_PLOTSCREEN)
				MapfileWriteSection(pSect);

			pSect = pSect->pNext;
		}
		MapfileCloseBank(area_Avail(BANK_PLOTSCREEN));

			

		//write the .8?p header
		//the file signature
		if( isPlus )
			fwrite("**TI83F*\x1A\x0A\x00",1,11,f);
		else
			fwrite("**TI83**\x1A\x0A\x00",1,11,f);

		//write the comment
		memset(comment,0,42);
		strcpy(comment,"Generated by RGBDS");
		fwrite(comment,1,42,f);

		//write the filesize
		if(options & OPT_UNSQUISHED)
		{
			dataSize = ((endOfProgram - beginningOfProgram)*2) + 2 + 9;
								//the 9 bytes is unsquished program overhead
		}
		else
		{
			dataSize = (endOfProgram - beginningOfProgram + 2);
		}

		if( isPlus )
			dataSize += 2; //two extra bytes for an additional data signature
				
		if( isPlus )
		{
			fputc((dataSize + 17) & 0x00FF, f);
			fputc(((dataSize + 17) >> 8) & 0x00FF, f);
		}
		else
		{
			fputc((dataSize + 15) & 0x00FF, f);
			fputc(((dataSize + 15) >> 8) & 0x00FF, f);
		}
		
		//the data section
		//signature
		if(isPlus)
		{
			fputc(0x0D, f);
			fputc(0x00, f);

			checksum += 0x0D;
		}
		else
		{
			fputc(0x0B, f);
			fputc(0x00, f);

			checksum += 0x0B;
		}

		//length of the variable data
		fputc(dataSize & 0x00FF, f);
		checksum += dataSize & 0x00FF;

		fputc((dataSize >> 8) & 0x00FF, f);
		checksum += (dataSize >> 8) & 0x00FF;


		//variable type ID.  6 if protected, 5 in unprotected
		if(options & OPT_UNPROTECTED)
		{
			fputc(0x05,f);
			checksum += 0x05;
		}
		else
		{
			fputc(0x06,f);
			checksum += 0x06;
		}

		//variable name (we just use the name of the output file minus the .83p
		//and in upper case);
		memset(varName,0,8);
		p = tzOutname;

		//strip out any directory names
		while(strstr(p,"\\"))
			p=strstr(p, "\\") + 1;

		while(strstr(p,"/"))
			p=strstr(p, "/") + 1;
				

		//copy over the file name
		for(index=0;p[index] != 0 && p[index] != '.' && index < 8; index++)
		{
			varName[index] = toupper(p[index]);
			checksum += varName[index];
		}
		fwrite(varName,1,8,f);

		if(isPlus)
		{
			//don't ask me why
			fputc(0x00, f);
			fputc(0x00, f);
		}

		//length of the variable data 		(again)
		fputc(dataSize & 0x00FF, f);
		checksum += dataSize & 0x00FF;

		fputc((dataSize >> 8) & 0x00FF, f);
		checksum += (dataSize >> 8) & 0x00FF;

		//length of the program data (yet again)
		//TI is weird.
		fputc((dataSize - 2) & 0x00FF, f);
		checksum += (dataSize - 2) & 0x00FF;
		fputc(((dataSize - 2) >> 8) & 0x00FF, f);
		checksum += ((dataSize - 2) >> 8) & 0x00FF;

		if( isPlus )
		{
			//Yet another data signature!
			fputc(0xBB, f);
			checksum += 0xBB;
			fputc(0x6D, f);
			checksum += 0x6D;
		}

		//the data itself
		//decide if the program is squished or undquished, and then write it
		if(options & OPT_UNSQUISHED)
		{
			verbose("Outputting in unsquished mode");

			//unsquish the program
			unsquishedIndex = 0;

			//output the actual bytes of the program
			for(index=beginningOfProgram; index < endOfProgram; index++)
			{
				if(((program[index] >> 4) & 0x0F) < 0x0A)
					unsquished[unsquishedIndex++] = ((program[index] >> 4) & 0x0F) + '0';
				else
					unsquished[unsquishedIndex++] = ((program[index] >> 4) & 0x0F) + 'A' - 10;

				if((program[index] & 0x0F) < 0x0A)
					unsquished[unsquishedIndex++] = (program[index] & 0x0F) + '0';
				else
					unsquished[unsquishedIndex++] = (program[index] & 0x0F) + 'A' - 10;
			}

			//add the end tokens
			memcpy(&unsquished[unsquishedIndex], "??0000?", 9);
			//memcpy(&unsquished[unsquishedIndex], "?123456789", 9);
			unsquishedIndex += 9;

			//output the program to the file
			fwrite(unsquished, 1, unsquishedIndex, f);

			//adjust the checksum
			for(index=0; index < unsquishedIndex; index++)
				checksum+=unsquished[index];

		}
		else
		{
			verbose("Outputting in squished mode");			

			//output the program
			fwrite(&program[beginningOfProgram], 1, endOfProgram - beginningOfProgram, f);
			
			//adjust the checksum
			for(index=beginningOfProgram; index < endOfProgram; index++)
				checksum+=program[index];
		}

		//and finally, the checksum
		fputc(checksum & 0x00FF, f);
		fputc((checksum >> 8) & 0x00FF, f);
		
		fclose( f );

		fclose(f);

	}
	else fatalerror("Could not open output file!");
}	


void	Output( void )
{
	if( oOutput )
	{
		switch( outputtype )
		{
			case OUTPUT_GBROM:
				GBROM_Output();
				break;
			case OUTPUT_PSION2:
				PSION2_Output();
				break;
			case OUTPUT_TI83:
				TI83_Output( 0 );
				break;
			case OUTPUT_TI83PLUS:
				TI83_Output( 1 );
				break;
		}
	}
}